#!/bin/sh

# creates spicey project structure in current working directory

# Call this script in the directory in which you want to generate
# your project. The only argument needed is the filename of the
# term file with the ER description. There is an optional argument
# --dbpath <path> where <path> specifies the prefix of the DB files
# in the generated ERD code (default: ".").

# note that there might be problems if a path includes spaces

ERROR=
ERDFILE=
DBPATH="."
if [ "$1" = "--dbpath" ] ; then
  shift; DBPATH=$1 ; shift
fi
if [ $# != 1 ] ; then
  echo "Wrong arguments!" >&2
  echo "Usage: .../spiceup.sh [--dbpath <dirpath>] <ERD term file>" >&2
  exit 1
fi

TARGETDIR=`pwd`                        # directory for the target code
PROGNAME=`type $0 | awk '{print $3}'`  # search for executable on path
PROGDIR=`dirname $PROGNAME`            # extract directory of program
# get absolute path:
ABSPROGDIR="`cd \"$PROGDIR\" 2>/dev/null && pwd || echo \"$PROGDIR\"`"
PROJGENDIR="$ABSPROGDIR/project_generator"
# ensure that path to termfile is absolute
TERMFILENAME=`basename $1`
TERMFILEDIR=`dirname $1`
ABSTERMFILEDIR="`cd \"$TERMFILEDIR\" 2>/dev/null && pwd || echo \"$TERMFILEDIR\"`"

cd "$TARGETDIR"

CURRYPATH="$ABSPROGDIR/scaffolding"
export CURRYPATH

pakcs -Dlibraries="$PROJGENDIR" -r "$PROJGENDIR/new.curry" "$TARGETDIR" "$PROJGENDIR" "$ABSTERMFILEDIR/$TERMFILENAME" "$DBPATH"
